#pragma hdrfile "drawfnt.sym"
#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <dos.h>
#pragma hdrstop

extern "C" void DrawFont(int, long, int);

char *Buff;
static char *str1="Яߜߏ߭ߛ߉߼׼߾߲",
	    *str2="߻ߙߤߤߌߤߌ",
	    *str3="߅ߝߏߜ",
	    *str4="ߌߝߏߜ";

int main(int argc, char *argv[])
{
  char *fName;
  int fHandle, Offset, Len, Size;
  long fLen;

  switch(argc)
  {
    case 2:
      Offset=0;
      Len=13;
      Size=8;
      break;

    case 3:
      Offset=atoi(argv[2]);
      Len=13;
      Size=8;
      break;

    case 4:
      Offset=atoi(argv[2]);
      Len=atoi(argv[3]);
      Size=8;
      break;

    case 5:
      Offset=atoi(argv[2]);
      Len=atoi(argv[3]);
      Size=atoi(argv[4]);
      break;

    default:
      for(int i=0; i<strlen(str1); i++)
	str1[i]=~str1[i];
      for(i=0; i<strlen(str2); i++)
	str2[i]=~str2[i];
      for(i=0; i<strlen(str3); i++)
	str3[i]=~str3[i];
      for(i=0; i<strlen(str4); i++)
	str4[i]=~str4[i];
      printf("%s\n", str1);
      printf("%s\n", str2);
      printf("%s\n", str3);
      printf("%s\n", str4);
      return -1;
  }

  printf("ESC/P compatible printer ROM dump viewer");

  if((fHandle=open(argv[1], O_BINARY | O_RDONLY))==-1)
    return -1;

  fLen=filelength(fHandle);
  lseek(fHandle, Offset, SEEK_SET);

  Buff=(char *)malloc(fLen-Offset+1);
  if(Buff==NULL)
    return -1;

  read(fHandle, Buff, (unsigned)fLen);
  close(fHandle);

  DrawFont(Len, fLen, Size);

  return 0;
}
