#include <dos.h>
#include <conio.h>
#include <string.h>
#include "keybrd.h"
#pragma hdrstop

extern "C" void DrawFont(int, long, int);

static char Mask8[8]={0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01};

static int Mask16[16]={0x8000, 0x4000, 0x2000, 0x1000, 0x0800, 0x0400, 0x0200, 0x0100,
		0x0080, 0x0040, 0x0020, 0x0010, 0x0008, 0x0004, 0x0002, 0x0001};

static char *str1=" Up, PgUp, Left ",
	    *str2="Back  ",
	    *str3="Down, PgDn, Right ",
	    *str4="Forward  ",
	    *str5="+ - ",
	    *str6="Offset increase/decrease  ";

extern char *Buff;

void DrawFont(int Len, long fLen, int Size)
{
  int Ch=0, kPress=0, Pos=1, Offset=0;
  char Byte;
  int  Word;

  textbackground(BLACK);
  clrscr();
  textbackground(LIGHTGRAY);
  gotoxy(Pos, 25);
  textcolor(RED);
  cprintf(str1);
  gotoxy(Pos+=strlen(str1), 25);
  textcolor(BLACK);
  cprintf(str2);
  gotoxy(Pos+=strlen(str2), 25);
  textcolor(RED);
  cprintf(str3);
  gotoxy(Pos+=strlen(str3), 25);
  textcolor(BLACK);
  cprintf(str4);
  gotoxy(Pos+=strlen(str4), 25);
  textcolor(RED);
  cprintf(str5);
  gotoxy(Pos+=strlen(str5), 25);
  textcolor(BLACK);
  cprintf(str6);

  window((80-Len)/2-1, (25-Size)/2-1, (80-Len)/2+Len, (25-Size)/2+Size);
  textcolor(WHITE);
  textbackground(BLUE);

  putch(0xDA);
  gotoxy(Len+1, 1);
  putch(0xB7);
  gotoxy(Len+1, Size+2);
  putch(0xBC);
  gotoxy(1, Size+2);
  putch(0xD4);

  for(int x=2; x<Len+1; x++)
  {
    gotoxy(x, 1);
    putch(0xC4);
    gotoxy(x, Size+2);
    putch(0xCD);
  }

  for(int y=2; y<Size+2; y++)
  {
    gotoxy(1, y);
    putch(0xB3);
    gotoxy(Len+1, y);
    putch(0xBA);
  }

  do
  {
    switch(kPress)
    {
      case K_PL:
	if(Offset<12)
	  Offset++;
	else
	{
	  sound(3000); delay(50); nosound();
	}
	break;

      case K_MI:
	if(Offset)
	  Offset--;
	else
	{
	  sound(3000); delay(50); nosound();
	}
	break;

      case K_UP:
      case K_LF:
      case K_PU:
	if(Ch)
	  Ch--;
	else
	{
	  sound(3000); delay(50); nosound();
	}
	break;
      case K_DN:
      case K_RT:
      case K_PD:
	if(Ch<(fLen/Len))
	  Ch++;
	else
	{
	  sound(3000); delay(50); nosound();
	}
	break;
      case K_HM:
	if(Ch)
	  Ch=0;
	else
	{
	  sound(3000); delay(50); nosound();
	}
	break;
      default:
	break;
    }

    window(5, 1, 35, 1);
    textcolor(WHITE);
    textbackground(BLACK);
    cprintf("Char #: %4d OffSet: %#6x", Ch, int(Ch*Len+Offset));

    window((80-Len)/2, (25-Size)/2, (80-Len)/2+Len, (25-Size)/2+Size-1);
    textcolor(YELLOW);
    textbackground(BLUE);

    int i, j;

    if(Size==8)
      for(i=Len-1; i>0; i--)
      {
	Byte=*(Buff+Ch*Len+i+Offset);
	for(j=0; j<8; j++)
	{
	  gotoxy(i, j+1);
	  if( !(Byte & Mask8[j]) )
	    cprintf("%c", 0xB0);
	  else
	    cprintf("%c", 0xDB);
	}
      };
    if(Size==16)
      for(i=Len-2; i>0; i-=2)
      {
	Word=*(Buff+Ch*Len+i+Offset*2);
	for(j=0; j<16; j++)
	{
	  gotoxy(i, j+1);
	  if( !(Word & Mask16[j]) )
	    cprintf("%c", 0xB0);
	  else
	    cprintf("%c", 0xDB);
	}
      };
  } while( (kPress=getch())!=27 );

  window(1, 1, 80, 25);
  textcolor(LIGHTGRAY);
  textbackground(BLACK);
  clrscr();
}