;CyrillicKeyboardDriverv.1.05
;bySkullC0DEr

                .286
CSEG		SEGMENT	BYTE PUBLIC
		ASSUME	CS:CSEG,DS:CSEG
		ORG	100H
BEGIN:
		JMP	INIT_TSR
;-TSR-DATA--------------
TSR_DATA:
DEXT_CODE       EQU     RC_EXT                  ; DEFAULT SWITCH
DKEY_CODE       EQU     RC_KEY                  ; RIGHT CTRL
RUS_LAT         DB      00000000B
; RUSSIAN ٳ
; EXT KEY PRESSED ٳ
; WAIT FOR END CODE ٳ
; KEY REPEATED ٳ
; EXT KEY NOT USED 
TABLE_1         DB      '234567890-=',0,0       ; STANDART
                DB      '㪥',0,0      ; WITH LAT 'H'
                DB      '뢠஫',0,0,0
                DB      'ᬨ'
                DB      '"#$:,.;()_+',0,0
                DB      'H',0,0
                DB      '',0,0,0
                DB      ''
TAB_LEN         EQU     $-OFFSET TABLE_1
;-INT-09H-HANDLER-------
INT09_HAND      PROC    NEAR
                PUSH    DS
                PUSH    40H
                POP     DS
                PUSHA
                IN      AL,60H
                XOR     BX,BX
                MOV     AH,BYTE PTR CS:[BX]
                TEST    AH,01001000B            ; IS EXT CODE ALR PRESSED?
                JNZ     INT09_5                 ; OR NOT USED?
SM_CODE_2:
                CMP     AL,DEXT_CODE            ; IS EXT CODE?
                JNZ     INT09_6
                XOR     AH,01000000B            ; SET EXT CODE FLAG
                JMP     INT09_7
INT09_5:
                XOR     AH,01000000B            ; CLEAR EXT CODE FLAG
SM_CODE_3:
                CMP     AL,DKEY_CODE            ; IS SWITCH KEY PRESSED?
                JNZ     INT09_6
                TEST    AH,00100000B            ; IS END CODE?
                JZ      INT09_8
                OR      AH,00010000B            ; SET REPEAT FLAG
INT09_8:
                OR      AH,00100000B            ; SET END CODE FLAG
                JMP     INT09_7
INT09_6:
                TEST    AH,00100000B            ; WAITING FOR END CODE?
                JZ      INT09_7
                XOR     AH,00100000B            ; CLEAR EXT CODE FLAG
SM_CODE_4:
                CMP     AL,DKEY_CODE OR 80H     ; IS END CODE?
                JNZ     INT09_7
                TEST    AH,00010000B            ; REPEATING?
                JZ      INT09_9
                XOR     AH,00010000B            ; RESET REPEAT FLAG
                JMP     INT09_7
INT09_9:
                XOR     AH,10000000B            ; SWITCH RUS/LAT
        ;-SET-BORDER----
                PUSH    AX
                SHR     AH,7                    ; BLUE OR BLACK
                MOV     DX,3DAH
                IN      AL,DX
                MOV     DX,3C0H
                MOV     AL,11H
                OUT     DX,AL
                MOV     AL,AH
                OUT     DX,AL                   ; SET NU BORDER COLOR
                MOV     AL,20H
                OUT     DX,AL
                POP     AX
        ;-SETUP-NU-VAL--
INT09_7:
                MOV     BYTE PTR CS:[BX],AH
        ;-DECODER-PROC--
                MOV     SI,WORD PTR DS:[1CH]
                PUSHF
                DB      09AH                    ; CALL FAR
INT09_OLD       DB      'HacK'
                CMP     SI,WORD PTR DS:[1CH]    ; KEYBOARD TAIL
                JZ      INT09_EX
                TEST    AH,10000000B            ; CHECK RUS/LAT FLAG
                JZ      INT09_EX
        ;-NOISE---------
SM_CODE_1:
                JMP     INT09_11
                XOR     AL,2                    ; SWITCH SPEAKER ON|OFF
                AND     AL,0FEH                 ; STOP TIMER B
                OUT     61H,AL
INT09_11:
        ;-DECODE--------
                MOV     AX,WORD PTR DS:[SI]
                XOR     BX,BX
                SUB     AH,3
                CMP     AH,35H-3                ; IS IN RANGE?
                JA      INT09_EX
                CMP     AL,20H                  ; NO ALT OR CTRL?
                JBE     INT09_EX
                MOV     AL,BYTE PTR DS:[17H]    ; SHIFT FLAG
                TEST    AL,3                    ; IS SHIFT PRESSED?
                JZ      INT09_1
                XOR     BL,TAB_LEN/2
INT09_1:
                CMP     AH,0EH-3                ; DIGITS?
                JB      INT09_2
                TEST    AL,40H                  ; CAPS LOCKED?
                JZ      INT09_2
                XOR     BL,TAB_LEN/2
INT09_2:
                MOV     AL,AH
                ADD     BX,OFFSET TABLE_1 - OFFSET TSR_DATA
                XLAT    CS:[BX]                 ; PARSE NU ASCii CODE
                OR      AL,AL
                JZ      INT09_EX
                CMP     AL,0F0H                 ; ''?
                JZ      INT09_10
                CMP     AL,0E0H                 ; ''?
                JNZ     INT09_4
INT09_10:
                MOV     BYTE PTR DS:[SI+1],0    ; FUCKIN' BIOS :-E~~~
INT09_4:
                MOV     BYTE PTR DS:[SI],AL     ; REPLACE OLD ASCii
INT09_EX:
                XOR     BYTE PTR DS:[3EH],1     ; RESET DETECTION FLAG
                POPA
                POP     DS
                IRET
INT09_HAND      ENDP
DRV_LEN         EQU     $-TSR_DATA
;-LOAD-TSR--------------
INIT_TSR	PROC	NEAR
;-WRITE-LOGO------------
                MOV     DX,OFFSET LOGO_STR
                MOV     AH,9
                INT     21H
;-ANALYZE-COM-STRING----
ANA_COM:
                MOV     BL,80H
                MOV     AL,BYTE PTR DS:[BX]
                OR      AL,AL
                JZ      CHK_PRE
                INC     BX
;-HELP-NEED?------------
                MOV     DI,BX
                CBW
                XCHG    CX,AX
                MOV     DX,CX
                MOV     AL,'?'
                REPNZ   SCASB                   ; HELP REALLY NEED?
                JNZ     IN_TS_2
                MOV     DX,OFFSET HELP_STR      ; DISLPAY IT
HE_NE_1:
                MOV     AH,9
                INT     21H
                RETN                            ; AND FUCK OUT
;-PARSER-PART-----------
PAR_PAR:
                INC     SI
                INC     SI
                LODSW
                OR      AL,AL
                MOV     DI,BX
                MOV     CX,DX
                RETN
IN_TS_2:
;-ATTEMPT-FOUND-KEY-OPT-
                MOV     SI,OFFSET KEY_OPT-2
AT_KE_1:
                CALL    PAR_PAR
                JZ      AT_KE_2
                DEC     SI
                REPNZ   SCASB
                JNZ     AT_KE_1
                LODSW
                XCHG    SI,AX
                MOV     DI,OFFSET TABLE_1
                MOV     CX,TAB_LEN
                REP     MOVSB
AT_KE_2:
;-WANNA-MAKE-SOME-NOISE-
                CALL    PAR_PAR
                MOV     AL,'N'
                REPNZ   SCASB
                JNZ     WA_NO_1
                MOV     WORD PTR DS:SM_CODE_1,NOIS_SMC  ; REPLACE 'JMP' TO 'IN'
WA_NO_1:
;-ATTEMPT-FOUND-SWITCH--
                MOV     SI,OFFSET SWT_OPT-2
AT_SW_1:
                CALL    PAR_PAR
                JZ      AT_SW_2
                REPNZ   SCASB
                JNZ     AT_SW_1
                CMP     AH,BYTE PTR DS:[DI]
                JNZ     AT_SW_1
                LODSW
                MOV     BX,OFFSET RUS_LAT
                AND     BYTE PTR DS:[BX],11110111B      ; CLEAR NOEXT FLAG
                MOV     BYTE PTR DS:SM_CODE_2+1,AL      ; SET NU EXT CODE
                OR      AL,AL
                JNZ     AT_SW_3
                OR      BYTE PTR DS:[BX],00001000B      ; SET NOEXT FLAG
AT_SW_3:
                MOV     BYTE PTR DS:SM_CODE_3+1,AH      ; SET NU KEY CODE
                OR      AH,80H
                MOV     BYTE PTR DS:SM_CODE_4+1,AH      ; SET NU ENDKEY CODE
AT_SW_2:
;-CHECK-FOR-PRESENCE----
CHK_PRE:
                PUSH    40H
                POP     DS
                MOV     AL,DS:[3EH]
                INT     9
                CMP     AL,DS:[3EH]
                PUSH    CS
                POP     DS
                JZ      REL_ENV
                MOV     AH,11H
                INT     16H
                JZ      CH_PR_1
                MOV     AH,10H
                INT     16H
CH_PR_1:
                MOV     DX,OFFSET ALOAD_STR
                JMP     HE_NE_1
;-RELEASE-ENVIROMENT----
REL_ENV:
                MOV     ES,WORD PTR DS:[2CH]
                MOV     AH,49H
                INT     21H
;-GET-OLD-INT09-VEC-----
                MOV     AX,3509H
                INT     21H
                MOV     WORD PTR DS:INT09_OLD,BX
                MOV     WORD PTR DS:INT09_OLD+2,ES
;-DUPLICATE-CURRENT-PSP-
                MOV     DX,DS
                ADD     DX,END_MAIN/10H+1
                MOV     BP,DX
                XOR     SI,SI
                MOV     AH,55H
                INT     21H
;-PATCH-NU-PSP----------
                MOV     ES,BP
                MOV     AX,WORD PTR DS:[16H]    ; GET PARENT PSP SEGMENT
                MOV     WORD PTR ES:[16H],AX    ; REPLACE IT IN NU PSP
;-RELEASE-ALL-----------
                PUSH    CS
                POP     ES
                MOV     AH,49H
                INT     21H
;-GET-OLD-ALLOC-STRATG--
                MOV     AX,5800H
                INT     21H
                PUSH    AX
;-SET-NU-ALLOC-STRATEGY-
                AND     AL,0FCH                         ; SELECT BEST FIT
                OR      AL,1                            ; ALLOC STRATEGY
                XCHG    BX,AX
                MOV     AX,5801H
                INT     21H
;-ALLOC-MEM-FOR-DRIVER--
                MOV     AH,48H
                MOV     BX,DRV_LEN/10H+1                ; SIZE IN PARA
                INT     21H
                DEC     AX
                MOV     ES,AX
;-PATCH-MCB-------------
                XOR     DI,DI
                MOV     SI,OFFSET MY_MCB
                MOV     CX,16
                REP     MOVSB
;-MOVE-DRV-TO-NU-LOC----
                MOV     SI,OFFSET TSR_DATA
                MOV     CX,DRV_LEN
                REP     MOVSB
;-RESTORE-OLD-ALL-STRAT-
                POP     BX
                MOV     AX,5801H
                INT     21H
;-SET-NU-INT09-VECTOR---
                MOV     AX,ES
                INC     AX
                MOV     DS,AX
                MOV     AX,2509H
                MOV     DX,OFFSET INT09_HAND - OFFSET TSR_DATA
                INT     21H
;-SET-NU-PSP------------
                MOV     BX,BP
                MOV     AH,50H
                INT     21H
;-EXIT------------------
                MOV     AX,4C66H
                INT     21H
INIT_TSR	ENDP
;-PROGRAM-DATA----------
CR              EQU     0DH
LF              EQU     0AH
MY_MCB          DB      'M'                     ; NOT THE LAST ;)
                DW      8                       ; OWNER DOS ;)))
                DW      DRV_LEN/10H+1           ; DRIVER LENGTH
                DB      'SkC'                   ; MY SHORT LOGO
                DB      '-=CKD!=-'              ; DRIVER NAME
LOGO_STR        DB      'Cyrillic Keyboard Driver v.1.05 by SkullC0DEr',CR,LF,'$'
ALOAD_STR       DB      'Already loaded!',CR,LF,'$'
HELP_STR        DB      CR,LF,'CKD [?][N][D|F|U][CL|LS|LC|LA|RA|RC|RS]',CR,LF,'$'
KEY_FIDO        DB      '234567890-=',0,0       ; EXTREMLY
                DB      'yex',0,0      ; FIDO
                DB      'apo',0,0,0
                DB      'cm'
                DB      '"#$:,.;()_+',0,0
                DB      'YKEH3X',0,0
                DB      'BAPO',0,0,0
                DB      'CMT'
KEY_UKR         DB      '234567890-=',0,0       ; UKRAINIAN
                DB      "㪥'",0,0
                DB      '䨢஫',0,0,0
                DB      'i'
                DB      '"#$:,.;()_+',0,0
                DB      "'",0,0
                DB      '',0,0,0
                DB      'I'
        ;-SWITCHES------
CL_EXT          EQU     0
CL_KEY          EQU     3AH
LS_EXT          EQU     0
LS_KEY          EQU     2AH
LC_EXT          EQU     0
LC_KEY          EQU     1DH
LA_EXT          EQU     0
LA_KEY          EQU     38H
RA_EXT          EQU     0E0H
RA_KEY          EQU     38H
RC_EXT          EQU     0E0H
RC_KEY          EQU     1DH
RS_EXT          EQU     0
RS_KEY          EQU     36H
        ;-OPTIONS-------
KEY_OPT         DB      'D'                     ; OPTION
                DW      OFFSET TABLE_1          ; KEY TABLE OFFSET
                DB      'F'
                DW      OFFSET KEY_FIDO
                DB      'U'
                DW      OFFSET KEY_UKR
                DB      0                       ; END STRUCTURE
SWT_OPT         DB      'CL'                    ; OPTION
                DB      CL_EXT,CL_KEY           ; EXT CODE, SCAN CODE
                DB      'LS'
                DB      LS_EXT,LS_KEY
                DB      'LC'
                DB      LC_EXT,LC_KEY
                DB      'LA'
                DB      LA_EXT,LA_KEY
                DB      'RA'
                DB      RA_EXT,RA_KEY
                DB      'RC'
                DB      RC_EXT,RC_KEY
                DB      'RS'
                DB      RS_EXT,RS_KEY
                DB      0                       ; END STRUCTURE
NOIS_SMC        EQU     61E4H                   ; IN AL,61H
END_MAIN        EQU     $-OFFSET BEGIN+100H
;-END-SEGMENT-----------
CSEG		ENDS
		END	BEGIN
