;
;			  Display Saver Version 4.52
;	     ணࠬ   ᯮ짮
;	DOS Swapable Data Area  ᯥ祭 襩 ᯫ뢠
;	    १ ணࠬ  ᫮ ॥࠭⭮ DOS.
;			     ਬ:
;		       Alexey Kulentsov, 2:5020/216.6
;		       Alexey Pavlov,    2:5020/139.8
;
;
;  砭  ࣠樨 ணࠬ.
; ᪮ ᭮ 楫 ⮩ ணࠬ- 祡,   ᠭ 
;   ⨬쭮 뫠 ਭᥭ   ᭮.  
; 祭 ﬨ, 稭騬  ᨬ ;O.
;
		.model	tiny
		.code
;
; p p ⠭.
;
McbId		equ	0
McbOwner	equ	1
McbSize		equ	3
MismatchBytes	equ	20
Environment	equ	2CH
CommLineStart	equ	81H
CommLineSize	equ	80H
KbdBufferTail	equ	1CH
ActivePage	equ	44EH
Rows		equ	484H
Columns		equ	44AH
StackSize	equ	10H
DsaStart	equ	(offset LastByte + (StackSize shl 4))
StackTop	equ	DsaStart
;
; p塞 pp, ᯮ㥬 p p墠 p.
;
Hook		struc
Number		db	?		; Hp pp뢠.
SaveAddress	dw	?		; p   p p.
NewAddress	dw	?		; p  p楤p p稪.
Hook		ends

		org	5CH
;
;  p,  ⮬ ᫥  室 䠩, 㤮 p  PSP,
;  ᢮  ⠬ 筮.
;
SavedStack	dd	?	; ⥫  p ⥪ DOS.
SavedInt9	dd	?	;
SavedInt13	dd	?	; p p pp뢠.
SavedInt2A	dd	?	;
SavedInt2F	dd	?	;
DsaPtr		dd	?	; ⥫  DSA.
DsaSize		dw	?	; p DSA.
FileName	dw	?	; ⥫   䠩, 饥  PSP.
Function	dw	?	; p  p p 㭪樨 int 2F
VideoRam	dw	?	;  p .
CriticalSection	dw	?	;  ⨢ p᪨ ᥪ権 0..F
Flags		db	?	; H᪮쪮 ⮢ 䫠, p .
;
;  p Flags ppp ᥣ 4  .   祭.
;
KeyPressed	equ	(1 shl 0)	; , 騩 ⨥ p祩 .
Progress	equ	(1 shl 1)	;  ⨢ ᭮ p楤p.
BiosActive	equ	(1 shl 2)	;  ⨢ ᪮ p権.
WindowsActive	equ	(1 shl 3)	;  ⨢ Windows.

		org	100H
	Start:
		jmp	Install

;
; p楤p Int9Handle p⠢ ᮡ p稪 9 pp뢠. p稪
; 砥  ⮩  ⥬ 맮 ⠭p⭮ p稪 BIOS.
; ᫥ 頥 p  p p, 㤠    p.
; ᫨ 뫠  p , ⠢ ᮮ. 䫠,   
;   p, ⮡   p㣨 pp.
;

Int9Handle	proc	far
		push	ds bx
;
;  㪠⥫  p p    BIOS
;
		mov	bx, 40H
		mov	ds, bx
		mov	bx, ds:[KbdBufferTail]
;
; 뢠 p p稪 int 9.    p p 
; ⮩ .
;
		pushf
		call	cs:[SavedInt9]
;
; pp塞 䫠  p祩 , ⮡   p
; 宦  p稪   ᭮ pp.
;
		test	cs:[Flags], KeyPressed
		jne	ExitInt9Handle
;
; pp塞, ⢨⥫쭮   p - .
;
		cmp	bx, ds:[KbdBufferTail]
		je	ExitInt9Handle
;
; pp塞,   "" p  - <CtrlF12>. ᫨ , 㤠塞
;   p, ⠭ 䫠  .
;
		cmp	word ptr ds:[bx], 8A00H
		jne	ExitInt9Handle
		mov	word ptr ds:[KbdBufferTail], bx
		or	cs:[Flags], KeyPressed
;
; pp塞 ﭨ p 䫠, ᫨  - ⨢p㥬.
;
		call	CheckFlags
	ExitInt9Handle:
		pop	bx ds
		iret
Int9Handle	endp

;
; p楤p Int2AHandle - p稪 pp뢠 2A. H祭 p稪 -
; ᫥  맮 ⮣ pp뢠  DOS, ⮡ , 室  DOS
;  饥 p  p᪮ ᥪ樨. ﭨ p p᪨
; ᥪ権 ⮡p  䫠 CriticalSection. ᫨  㫥,   
;  ⨢.
;

Int2AHandle	proc	far
		push	ax
;
; 맮 int 2A/AH = 80H ⬥砥 砫 p᪮ ᥪ樨.  ᥪ権
;   ᪮쪮 , p ᥪ樨 p  AL  p 祭
; 0..0F.  p CriticalSection   ⢥  . GetSectionId
; pp p ᥪ樨  AL    CriticalSection. ⥬ ᮮ.
;  ⠭,  p  ⨢  .
;
		cmp	ah, 80H
		jne	CheckSectionEnd
		call	GetSectionId
		or	cs:[CriticalSection], ax
;
; 맮 int 2A/AH = 81H ᢨ⥫  砭 p᪮ ᥪ樨 
; p AL. p⪠ 筠 p饬 ,  祭 ᪠
; ᯮ  p ᮮ⢥ ⮢ .
;
	CheckSectionEnd:
		cmp	ah, 81H
		jne	Check7SectionEnd;	NotSection
		call	GetSectionId
		not	ax
		and	cs:[CriticalSection], ax
;
; 맮 int 2A p AH = 82H 砥 砭 p 쬨   p 0..7.
; H  p ⮬ p p 8  ⮢ p CriticalSection
;    p樥.
;
	Check7SectionEnd:
		cmp	ah, 82H
		jne	NotSection
		mov	byte ptr cs:[CriticalSection], 0
	NotSection:
		pop	ax
;
; pp塞 ﭨ p 䫠, ᫨  - ⨢p㥬.
;
		call	CheckFlags
		jmp	dword ptr cs:[SavedInt2A]
Int2AHandle   	endp

;
; p楤p Int13Handle ᫥  맮 int 13. ᫨ int 13  饥
; p 믮, ᮮ. 䫠 BiosActive ⠭.  䫠
; ᯮ  pp ᮢ⭮  䫠 p᪮ ᥪ樨 
; p  pp ⥪騥 p樨 DOS. Hᬮp  , 
; DOS p稢 맮 int 13  ᢮ pp p᪨ ᥪﬨ 2-
; ⨯, p㣨 pp  ᠬ⥫쭮 뢠 int 13, ,  䫠
; BiosActive  .
;

Int13Handle	proc	far
		or	cs:[Flags], BiosActive
;
; 뢠 p p稪.
;
		pushf
		call	cs:[SavedInt13]
		pushf
;
; 맮 int 13 p襭. p뢠 ᮮ⢥騩 䫠.
;
		and	cs:[Flags], not BiosActive
;
; pp塞 ﭨ p 䫠, ᫨  - ⨢p㥬.
;
		call	CheckFlags
		popf
		retf	2
Int13Handle	endp

;
; p楤p Int2FHandle  ᫥ ᪠/p襭 Windows.
;   ⥬ p墠 㭪権 1605/1606 ᮮ⢥⢥.  Windows
; p㦥, p pp , .. Windows ᠬ  DOS 
; ⨢樨  2- ⨯,   p襭 p頥   室
; ﭨ. ⮬  , ᤥ   ᪠ Windows,
; 뢠 pﭭ묨. p ᭮  DOS.  p p
; Windows ⠭ 䫠 WindowsActive, 騩  ᯫ뢠
; p.    㦭, .. Windows  p ⠭ ᢮
; p稪 p.
;

Int2FHandle	proc	far
;
; H室 p  楯 p稪  ᥡ, .. p饥
;  ⠭ ﭨ DOS p室  ᠬ 㡮  .
; ⮡   p ᮤp AX, p塞 .
;
		mov	cs:[Function], ax
;
; 뢠 p p稪.
;
		pushf
		call	cs:[SavedInt2F]
;
; Hp 㭪樨 int 2F p p  䫠. ⮡  p
; p  뢠饩 pp, p塞 䫠. p p⮬ 
; ⠭.
;
		pushf
;
; p ᪥ Windows 뢠 int 2F / AX=1605 ᯥ樠쭮  ⮣, ⮡
; 㢥   ᥡ. ⠭ 䫠 WindowsActive, 騩 
; ⨢ p - Windows.
;
		push	ax
		mov	ax, cs:[Function]
		cmp	ax, 1605H
		jne	NoWindowsStart
		or	cs:[Flags], WindowsActive
;
; 筮 int 2F / AX=1606 뢠 Windows, ⮡ ppp 
;  p襭 ᨨ Windows. p뢠 䫠 WindowsActive  稬 DOS.
; ⮡   p뢠 -  p祩   p
; ᨨ Windows, p뢠  䫠 KeyPressed.
;
	NoWindowsStart:
		cmp	ax, 1606H
		jne	ExitInt2FHandle
		and	cs:[Flags], not (WindowsActive or KeyPressed)
		push	si di
		call	PatchDos
		pop	di si
	ExitInt2FHandle:
		pop	ax
		popf
		retf	2
Int2FHandle	endp

;
; p楤p Int24Handle - p稪 pp뢠 24. DOS 뢠   砥
;  p᪮ 訡. H祭 p稪 -  
;   p  "Abort, Retry, Ignore, Fail?".  ⮣
; p稪 ᠬ ⢥砥   p  "Fail".
;

Int24Handle	proc	far
		mov	al, 3
		iret
Int24Handle	endp

;
; p楤p CheckFlags pp 믮 ᫮ pp뢠 ⥪ p権
; DOS. ᫨ pp뢠 , 뢠 pp p祭 PopUp.
;
;  室 pp: .
;
;  室 稭: .
;

CheckFlags	proc	near
;
; p ᠭ p楤p ⨢樨     饥:
;
; 1 -  KeyPressed ⠭ p ⨨  p . ,
;      ⨢p pp ⮫쪮 p ⠭ KeyPressed.
;
; 2 -   ᯫ뢠 DOS   室    . ⥫쭮,
;     易⥫ ᫮ ⨢樨  㫥  䫠 :
;     CriticalSection  BiosActive
;
; 3 -   ᯫ뢠    ⨢ Windows, 䫠 WindowsActive
;       p襭.
;
; 4 - ⮡  p 室  ᭮ p楤p, pp塞 䫠 
;     ⨢ Progress. ᫨ p楤p 㦥 ⨢,  ⮨ 뢠 
;      p.
;
; p pp ᯥ稢 p⢮  䫠 BiosActive, Progress,
; WindowsActive   䫠 KeyPressed. p - p⢮ 
; 16- 䫠 .
;
		cmp	cs:[Flags], KeyPressed
		jne	UnablePopUp
		cmp	cs:[CriticalSection], 0
		jne	UnablePopUp
;
; 뢠 ᭮ p楤p, p  p p  䠩.
;
		call	PopUp
	UnablePopUp:
		ret
CheckFlags	endp

;
; p楤p GetSectionId pp p p᪮ ᥪ樨  al  16-
; ,  p ⠭ ⮫쪮 pp  p al.  ⨬
; 祭  al = [0..0F], p㣨 祭 p뢠.
;
;  室 pp: al -> p p᪮ ᥪ樨.
;
;  室 稭: ax -> ᮮ⢥ ⮢ ᪠.
;

GetSectionId	proc	near
		push	cx
		and	al, 0FH
		mov	cl, al
		mov	ax, 1
		shl	ax, cl
		pop	cx
		ret
GetSectionId	endp

;
; p楤p PopUp 믮 ⢨, 室  砫 p ᭮
; p楤p p p.  ᢮ DSA, p ⥪  p
; ppp , ⠭ ᢮ p稪  p᪨
; 訡 DOS. ᫥ 믮 ᭮ p楤p p p 
; ⠭  室 ﭨ.
;
;O 쪮  맮 -  楤ਢ.
;
;  室 pp: .
;
;  室 稭: .
;

PopUp		proc	near
;
; p頥 ⥪   , ⮡   pᥪ  p ⥪
; DOS. ⠭ 䫠 ⨢ ᭮ pp, ⮡ 
; p   室,  뢠 䫠 .
;
		cli
		mov	word ptr cs:[SavedStack + 2], ss
		mov	word ptr cs:[SavedStack], sp
		mov	sp, cs
		mov	ss, sp
		mov	sp, StackTop
		push	ds es si di dx cx bx ax
		xor	cs:[Flags], (Progress + KeyPressed)
;
;  p  DSA 砥  ⮬, ⮡  p-⠭
; DSA ᫥ p p,  㯨 ᮮp  , .. ᢮.
;  ⮣ p 砫 ᭮ p p塞 p "" DSA,  
;   頥 "᢮" DSA,    ⠫樨 pp,
;  DOS 뫠 pp ᢮,  InDosFlag = 0. p
; ᭨ p p室  p PSP, DTA , ..  pᠭ  DSA.
;
		call	SwapDsa
;
;O  ᯮ짮   ਬ ᯮᮡ  䠩 int 24 맢
;    ⮬ 墠 ⮣  易⥫,   ⠢, ⠪
;   㣨   室. ਬ, ᫨ ॡ ࠡ ⮩
; ணࠬ  MSDOS 3.3  䠩 㤥 뢠  ⮤.
;
; p塞 p ⥪饣 p稪 p᪨ 訡 int 24  ⥪.
;
		sti
		mov	ax, 3524H
		int	21H
		push	bx es
;
; ⠭ ᢮ p稪 int 24, p  㤥 pp 
;  p᪨ 訡 DOS.
;
		mov	dx, offset Int24Handle
		mov	ah, 25H
		int	21h
;
; p楤p SaveScreen ᮡ⢥  p ᮤp p  䠩.
;
		call	SaveScreen
;
; ⠭ p p稪 int 24.
;
		pop	ds dx
		mov	ax, 2524H
		int	21H
;
;  ""  "᢮" DSA p⭮.
;
		call	SwapDsa
;
; p⪠ pp p襭. p 室 p 䫠 ,
; ⮡ p   室 ﭨ.
;
		and	cs:[Flags], not Progress
		pop	ax bx cx dx di si es ds
;
; ⠭ ⥪.
;
		mov	ss, word ptr cs:[SavedStack + 2]
		mov	sp, word ptr cs:[SavedStack]
		ret
PopUp		endp

;
; p楤p SwapDsa  ⠬ DSA ࠧ஬ DsaSize   DsaPtr
;     cs:[DsaStart].
;
;  室 pp: .
;
;  室 稭: .
;

SwapDsa		proc	near
		push	cs
		pop	ds
		mov	si, DsaStart
		les	di, ds:[DsaPtr]
		mov	cx, ds:[DsaSize]
		cld
	SwapLoop:
		mov	al, es:[di]
		xchg	al, ds:[si]
		stosb
		inc	si
		loop	SwapLoop
		ret
SwapDsa		endp

;
; p楤p SaveScreen 믮 p ⨢ p  
; 䠩,  p㬥⮬ ds:[FileName]. p⪠ 訡 p 䠩
; p  pᬮp.
;
;O 쪮  맮 -  楤ਢ.
;
;  室 pp: ds:[FileName] -> 㪠⥫   䠩.
;
;  室 稭: .
;

SaveScreen	proc	near
;
; p뢠  䠩  p . ᫨ 䠩  , 
; ᮧ. ᯮ㥬   楫 㭪  ⮫쪮  4 pᨨ
; DOS.
;
		mov	ax, 6C00H
		mov	bx, 4001H
		mov	cx, 20H
		mov	dx, 11H
		mov	si, ds:[FileName]
		int	21H
		jc	Error
		mov	bx, ax
;
; 頥 㪠⥫ 䠩   .
;
		mov	ax, 4202H
		xor	cx, cx
		mov	dx, cx
		int	21H
		jc	Error
;
; ᯮ짮 p묨    BIOS, 塞 pp
; ⨢ p .
;
		xor	ax, ax
		mov	ds, ax
		mov	al, ds:[Rows]
		inc	al
		mul	byte ptr ds:[Columns]
		shl	ax, 1
		mov	cx, ax
;
; 襬 ⨢ p   䠩.
;
		mov	dx, ds:[ActivePage]
		mov	ds, cs:[VideoRam]
		mov	ah, 40H
		int	21H
		cmp	ax, cx
		jne	Error
;
; p뢠 䠩.
;
		mov	ah, 3EH
		int	21H
		ret
;
;  p   pᯮ pp p⪨ 訡. 
; p  訡 䠩 p p뢠.
;
;O  ᮢ  ଠ 襭-  ᤢ.
	Error:
		mov	ah, 3EH
		int	21H
		ret
SaveScreen	endp

;
; p楤p PatchDos  DOS  ⨢樨 ᪨ ᥪ権 2- ⨯.
; ᮪ pᮢ, p  , p  ᠬ DOS  p
; [DSA - 0BH]. ᮪ 稢 㫥 ᫮,   ᯮ 
; 砭 p楤p.
;
;  室 pp: .
;
;  室 稭: .
;

PatchDos	proc	near
		push	ds
		lds	si, cs:[DsaPtr]
		sub	si, 0BH
	PatchLoop:
		lodsw
		and	ax, ax
		jz	PatchComplete
		mov	di, ax
		or	byte ptr ds:[di], 1
		jmp	PatchLoop
	PatchComplete:
		pop	ds
		ret
PatchDos	endp

LastByte	label	near

;
; p楤p IsInstalled pp 稥    pp. 
; pp p頥   䫠 ZF.  砥   pp 
;   es p頥 ᥣ PSP ⮩ .
;
;  室 pp: .
;
;  室 稭: ZF -> pp 㦥 p  .
;		      es -> ᥣ PSP  pp (᫨ ).
;

IsInstalled	proc	near
;
; 砥 ᥣ p p MCB.   筥   pp.
;
		mov	ah, 52H
		int	21H
		mov	bx, es:[bx - 2]
;
; p pp MCB 室 㡥,    ᫥  
; 楯窥,   - p    pp  
; p  Saver'.
;
	NextMcb:
		mov	es, bx
		cmp	byte ptr es:[McbId], 'M'
		jne	SearchComplete
		mov	ax, es:[McbSize]
		mov	cx, es:[McbOwner]
		inc	bx
		mov	es, bx
		add	bx, ax
		jcxz	NextMcb
		mov	si,cs
		cmp	cx,si
		je	NextMcb
		cmp	ax, (StackTop - Start + 100H) shr 4
		jb	NextMcb
;
; 뢠 p楤p p .  p頥 p  䫠 ZF.
;   䫠 p   p楤p  .
;
		call	CodeCompare
		jne	NextMcb
	SearchComplete:
		ret
IsInstalled	endp

;
; p楤p CodeCompare p  p⭮  pp  
; 室騬  ᥣ p㥬 pp es.  ᠬ p
; p㦥 pp  .
;
;O 쪮  맮 -  楤ਢ.
;
;  室 pp: es -> ᥣ,  p 㤥 p .
;
;  室 稭: ZF ->    ᥣ es.
;

CodeCompare	proc	near
		mov	cx, LastByte - Start
		mov	si, offset Start
		mov	di, si
		cld
		rep	cmpsb
		ret
CodeCompare	endp

;
; p楤p CreateFile ᮧ 䠩  , p   ⢥
; pp,  p  p뢠 .    楫 pp 
; ⨬    䠩.  砥 㤠 뤠 pp饥
; ᮮ饭   室  DOS.
;
;  室 pp: ds:[FileName] -> 㪠⥫  ASCIIZ  䠩  ⮬ 
;				       ᥣ.
;
;  室 稭: .
;

CreateFile	proc	near
		push	bx
		mov	ah, 3CH
		xor	cx, cx
		mov	dx, ds:[FileName]
		int	21H
		jc	CreateError
		mov	bx, ax
		mov	ah, 3EH
		int	21H
		pop	bx
		ret
	CreateError:
		mov	dx, offset BadName
		jmp	PrintText
CreateFile  	endp

;
; p楤p HookVectors p墠뢠 ᪮쪮 p, 室 
; p Saver'. p, ᯮ㥬 p楤p: p pp뢠,
; p p   p稪   ᨢ pp Vectors.
;
;O 쪮  맮 -  楤ਢ.
;
;  室 pp: .
;
;  室 稭: .
;

HookVectors	proc	near
		mov	si, offset Vectors
		mov	cx, HookCount
;
; 砥 p ⥪饣 p稪  pp뢠  p塞 .
;
	HookStart:
		mov	al, ds:[si.Number]
		mov	ah, 35H
		int	21H
		mov	di, ds:[si.SaveAddress]
		mov	ds:[di], bx
		mov	ds:[di + 2], es
;
; ⠭  p稪   pp뢠.
;
		mov	dx, ds:[si.NewAddress]
		mov	ah, 25H
		int	21H
		add	si, size Hook
		loop	HookStart
		ret
Vectors		Hook	< 9H,  SavedInt9,  Int9Handle>
		Hook	<13H, SavedInt13, Int13Handle>
		Hook	<2AH, SavedInt2A, Int2AHandle>
		Hook	<2FH, SavedInt2F, Int2FHandle>
HookCount	equ	(($ - Vectors) / size Hook)
HookVectors	endp

;
; p楤p Test4Remove ஢,   㧪 dsaver  .
; 㧪 ⠥ , ᫨    ஢  墠祭 
; 墠祭 ⮫쪮  2F    ᨤ VC. p  p墠祭
; p p  ⮣  ᨢ pp Vectors.
;
;O 쪮  맮 -  楤ਢ.
;
;  室 pp: es -> ᥣ १⭮  ணࠬ.
;
;  室 稭: ZF -> ⠭, ᫨ 㧪 .
;

Test4Remove	proc	near
		mov	cx, HookCount
		mov	dx, es
		mov	si, offset Vectors
;
; 稫 ⥪騩 p .
;
	TestVector:
		mov	ah, 35H
		mov	al, ds:[si.Number]
		int	21H
;
; ࠢ  pc  pᮬ ᢮ p稪. ᫨  ᮢ, p
;   p墠祭.
;
		mov	ax, es
		cmp	ax, dx
		jne	FailComp
		cmp	bx, ds:[si.NewAddress]
		jne	FailComp
;
;  横. p室  ᫥饬 p.
;
		add	si, size Hook
		loop	TestVector
;
; ᫨   ,    p   p墠祭.  p㦠
; १  dSaver.
;
		mov	es, dx
		xor	al, al
		ret
;
;   VC. ⠥,  ᫨ 墠祭 ⮫쪮  2F    
; VC,  㧨 .  室, ⠪  VC 墠뢠 Int 2F 
; 饭 -  dsaver  ⮣ 㧨  ᬮ.  VC 
; 㦠  ᥣ ࠢ쭮.  ᫨ ந஢ 墠 2F  
; 㧨 ᠬ,  १⮢ VC ࠡ뢠  ࠢ쭮.
;
	FailComp:
;
;  cx ᮤp p p,  p  pp. cx = 1
; ᮮ⢥ p int 2F.
;
		cmp	cl, 1
		jne	TestReturn
;
; 뢠 㭪 䥩 VC.
;
		push	ax dx
		mov	cx, 'VC'
		mov	dx, 'OM'
		mov	ax, 2B00H
		int	21H
;
;  砥 p⢨ VC   ⮫쪮  ᤥ 맮  p
; al = 0. pp塞 .
;
		cmp	al, 0

		pop	dx ax
		mov	es, dx
	TestReturn:
		ret
Test4Remove     endp

;
; p楤p Remove p㦠 pp  , ᫨  .  ⮣
;  p ⠭ p墠祭 p pp뢠  ᢮
;  pp  .
;
;O 쪮  맮 -  楤ਢ.
;
;  室 pp: es -> ᥣ  pp.
;
;  室 稭: .
;

Remove		proc	near
;
; pp  p㧨, ᫨ p墠祭  p ⠫ 
; p᭮.  ᫮ pp p楤p Test4Remove.
;
		call	Test4Remove
		jne	NotRemove
;
; ⠭ p墠祭 .  es 室 ᥣ १⭮
; .   pp ⠪,   p墠뢠 .
;
		mov	cx, HookCount
		mov	si, offset Vectors
	RestoreVector:
		mov	bx, cs:[si.SaveAddress]
		lds	dx, es:[bx]
		mov	ah, 25H
		mov	al, cs:[si.Number]
		int	21H
		add	si, size Hook
		loop	RestoreVector
;
; ⨬  , ਭ騩 १⭮ .
;
		mov	ah, 49H
		int	21H
;
; ⠥ ᮮ饭  㧪  p蠥 p.
;
		push	cs
		pop	ds
		mov	dx, offset Removed
		jmp	PrintText
;
;  ,    㧨 ।  ணࠬ.
; ⠥ ᮮ饭  ⮬.
;
	NotRemove:
		mov	dx, offset DontRemoved
		mov	ah, 9
		int	21H
		ret
Remove		endp

;
;   ࠢ  ᪥ ணࠬ.
;
	Install:
;
; p  pp塞 p DOS.     4, .. -p,
;  pp  㥬 㭪樥, 饩  p p,  -
; p,  DOS 4+  p ᪠ SHARE.EXE  ⨢樨 p᪨
; ᥪ権 1- ⨯.
;
		mov	ah, 30H
		int	21H
		cmp	al, 4
		jae	ResetFlags
		mov	dx, offset BadDos
		jmp	PrintText
;
; 樠 ६. p뢠 䫠 p᪨ ᥪ権.
;
	ResetFlags:
		mov	ds:[Flags], 0
		mov	ds:[CriticalSection], 0
;
; ᢮  ,  p㦥.   p.
;
		mov	es, ds:[Environment]
		mov	ah, 49H
		int	21H
;
; ⠥  pp  p.
;
		mov	dx, offset PName
		mov	ah, 9
		int	21H
;
; 頥  si 㪠⥫   p,  cx -  pp. ᫨ pp
; 㫥, p室   p樨 ᯮ짮 pp.
;
		mov	si, CommLineStart
		mov	cl, ds:[CommLineSize]
		xor	ch, ch
		jcxz	DeInstall
;
;  p  稭  p  ⠡権. p᪠ .
; ᫨ p  ᨬ  p 祣 , ⠥ p.
;
		cld
	IgnoreSpace:
		lodsb
		cmp	al, ' '
		je	SpaceFound
		cmp	al, 9
		jne	TextFound
	SpaceFound:
		loop	IgnoreSpace
;
;  砥, ᫨  p     㦥   pp,
; p㦠 . ᫨  pp   , p ⠥ ᪠.
;
DeInstall:
		call	IsInstalled
		jne	PrintHelp
		call	Remove
;
; ⠥ p  ᯮ짮 pp. 稢 p.
;
	PrintHelp:
		mov	dx, offset Help
	PrintText:
		mov	ah, 9
		int	21H
		int	20H
;
; p ⮩ ᨬ ⠥ 砫  䠩. p塞 㪠⥫
;  .
;
	TextFound:
		dec	si
		mov	ds:[FileName], si
;
;  pp⭮ p DOS   䠩   p 㫥 ᨬ.
; 㤥 ,   䠩 砥,  ⮫쪮  p
; ⨬ ᨬ.
;
	KeyNotFound:
		lodsb
		cmp	al, ' '
		ja	KeyNotFound
		mov	byte ptr ds:[si - 1], ch
;
; pp塞,      pp.
;
		call	IsInstalled
		jne	NotInstalled
;
; ⠥ ᮧ 䠩, 㪠   p.  砥 ᯥ p
;   p饩  pp, ᥣ p - es. p p 
; pp 㤥 p    䠩.
;
		call	CreateFile
		mov	cx, offset Start - 1
		mov	si, ds:[FileName]
		mov	es:[FileName], si
		mov	di, si
		sub	cx, si
		cld
		rep	movsb
;
; 뢮 ᮮ饭  ᬥ  室 䠩. 稢 p.
;
		mov	dx, offset Renamed
		jmp	PrintText
;
;  , ᫨  pp    . p  pp塞
; ⨯ p  ⠭ p 砫 .
;
	NotInstalled:
		mov	ah, 0FH
		int	10H
		mov	ds:[VideoRam], 0B800H
		cmp	al, 7
		jne	ColorVideo
		mov	byte ptr ds:[VideoRam + 1], 0B0H
	ColorVideo:
		call	CreateFile
;
; 砥 p DOS Swappable Area. ᫨ p   , pp頥
; p.
;
		mov	ax, 5D06H
		int	21H
		jnc	AreaExist
		mov	dx, offset NoDsa
		jmp	PrintText
;
; p塞 㪠⥫  DSA   pp  ᢮ p.
;
	AreaExist:
		mov	word ptr cs:[DsaPtr + 2], ds
		push	cs
		pop	ds
		mov	word ptr ds:[DsaPtr], si
		mov	ds:[DsaSize], cx
;
; 稬 DOS  楫 ⨢樨 p᪨ ᥪ権 2- ⨯.
;
		call	PatchDos
;
; ⠭ ᢮ p稪  p㥬 p pp뢠.
;
		call	HookVectors
;
; 騩 蠣 - p DSA. H ᫨  祣  pp, DSA p
; ᮡ 믮騩    ᭥. ⮬  ७ ⠢訩
;  .  p ६⨬  ஢  ࠧ DSA.
;
		push	cs
		pop	es
		mov	si, offset MovedCode
		mov	di, si
		add	di, ds:[DsaSize]
		mov	cx, MovedSize
		push	di
		rep	movsb
;
;  룭㫨 㤠.
;
		ret
;
; p塞 ᢮ DSA  ,  DOS pp ᢮  InDosFlag
; p .
;
	MovedCode:
		mov	cx, ds:[DsaSize]
		mov	di, DsaStart
		lds	si, ds:[DsaPtr]
		cli
		rep	movsb
		sti
;
; ⠥ ᮮ饭  ⠫樨 pp.
;
		push	cs
		pop	ds
		mov	dx, offset Installed
		add	dx, ds:[DsaSize]     ;  뢠  ६饭 
		mov	ah, 9
		int	21h
;
; 塞,  ꥬ   ppp  DSA, ⥪ 
; ᠬ pp. ⠢塞 pp p⭮.
;
		mov	dx, offset DsaStart
		add	dx, ds:[DsaSize]
		int	27H

Installed	db	' Installed. Press <CtrlF12> to activate', 0DH, 0AH, '$'
MovedSize	equ	($ - offset MovedCode)

PName		db	' Display Saver V4.51'
Copyright	db	' Copyright (c) 1990,91,93,94, MSTU (', ??date, ')', 0DH, 0AH
		db	' by Alexey Kulentsov, 2:5020/216.6', 0DH, 0AH
		db	'  & Alexey Pavlov,    2:5020/139.8', 0DH, 0AH, '$'
Help		db	' Syntax: dsaver <Output_File_Name>', 0Dh, 0Ah, '$'
Removed		db	' Resident copy of dSaver removed from memory.', 0DH, 0AH, '$'
DontRemoved	db	" Vectors Hooked - resident part don't removed.", 0DH, 0AH, '$'
Renamed		db	' Output file reassigned.'
		db	' Press <CtrlF12> to activate', 0DH, 0AH, '$'
BadName		db	' File creation error.'
		db	' Look file name for syntax error.', 0DH, 0AH, '$'
NoDsa		db	0DH, 0AH, 'DOS Swapable area not supported.$'
BadDos		db	0DH, 0AH, 'DOS version 4.0+ needed.$'
		end	Start
