Program FindFile2;
uses
 Dos, Crt, TpString;
var
 I,J : Byte;
 Out : Text;
 Before, After : string;

const
 Stop : Boolean = False;

Procedure FileFind(Dir : PathStr);
 var
  FindName : String;

Procedure SearchDir(Dir : PathStr);
 Var
    SRec : SearchRec;
 begin
   if Stop then Exit;
   if Dir[Length(Dir)] <> '\' then Dir := Dir+'\';
   Write('                                                            '#13);
   Write(Dir,#13);
   if KeyPressed then Stop := ReadKey = #27;

   for I := 1 to ParamCount do
    begin
     FindName := ParamStr(I);
     if Pos('.',FindName) = 0 then FindName := FindName + '*.*';

     FindFirst(Dir + FindName, AnyFile, SRec);
     While DosError = 0 do
       begin
         With SRec do
          if Attr and (VolumeID + Directory) = 0 then
           WriteLn(Out,Before,#32,Dir + Name,#32,After);
         FindNext(SRec);
       end;
    end;
   FindFirst(Dir+'*.*', $17, SRec);
   While DosError = 0 do
     begin
       With SRec do
        if (Attr and Directory <> 0) and (Name[1] <> '.') then
         SearchDir(Dir+Name);
       FindNext(SRec);
     end;
 end;
begin
 SearchDir(Dir);
end;

function GetCurDrive: Char;
var
  r: Registers;
begin
  r.ah := $19;
  MSDOS(r);
  GetCurDrive := Char(r.al + $41);
end;

procedure SetCurDrive(Drive: Char);
var
  r: Registers;
begin
  r.ah := $0E;
  r.dl := Byte(Drive) - $41;
  MSDOS(r);
end;

procedure ValkDrives;
var
  SaveDrive, Drive, Ch: Char;
begin
  SaveDrive := GetCurDrive;
  for Ch := 'C' to 'Z' do
  begin
    SetCurDrive(Ch);
    Drive := GetCurDrive;
    if Drive = Ch then
    begin
     FileFind(Drive+':\');
     if Stop then Break;
    end;
  end;
  SetCurDrive(SaveDrive);
end;

Function ParseParam(const Key : String) : String;
var
 s,Result : string;
 PKey,I : Byte;
begin
 Result := '';
 s := StUpCase(String(Ptr(PrefixSeg,$80)^));
 PKey := Pos(Key,s);
 if PKey <> 0 then
  begin
   I := PKey + Length(Key);
   if Pos(#39,Copy(S,I,255)) <> 0 then
     Result := ExtractWord(1,Copy(S,I,255),[#39]);
   If Result = '' then
     while (s[i] <> ' ') and (i <= Byte(S[0])) do  begin
       Result := Result + S[i];
       inc(i);
     end;

  Delete(String(Ptr(PrefixSeg,$80)^),PKey, Length(Result) + Length(Key));
  end
 else Result := '';
 ParseParam := Result;
end;

begin
 Writeln('FileFind Copyright (C) by Dima Orlov, 2:461/27 , 1994');
 Writeln('Usage: ');
 Writeln('   FF fname1 fname2 ...');
 Writeln('or');
 Writeln('   FF fname1 fname2 ...');


 Writeln('Press Esc to stop');

 Before := ParseParam('/B');
 After  := ParseParam('/A');
 if ParamCount = 0 then Halt;
 Assign(Out,'');
 ReWrite(Out);
 if IOResult <> 0 then Halt;
 ValkDrives;
 Close(Out);
end.
