@echo off
echo ----------------------------------------------------------
echo TMi0SDGL v1.17b to v1.17c update patch.
echo:
echo This patch requires all original files from CPU117B.ZIP
echo archive or their patched versions to be present in current
echo directory. If they don't then press Ctrl-C to abort patch,
echo else press any key to apply patch.
echo ----------------------------------------------------------
pause
if not exist bupdate.exe goto noPatcher
if not exist cpu117c.bdf goto noPatch
echo Patching files, please be patient...
bupdate cpu117c.bdf
if errorlevel 1 goto errPatch
del *.org >nul
del *.00? >nul
del bupdate.exe >nul
del cpu117c.bdf >nul
cls
echo Patch successfully applied! Now you can delete RUNME.BAT file
echo and review files HISTORY.DOC and README.1ST to see what's new
echo in this release.
echo                           Thanx for your attention, good bye.
goto Quit
:errPatch
cls
echo ******* WARNING! *************************************************
echo There was an error while patching files --- either particular file
echo was not found or it was of invalid version. Please verify that all
echo files to be patched are present and of proper version and run this
echo batch again.
echo ******************************************************************
pause
goto Quit
:noPatcher
cls
echo Error: BUPDATE.EXE file not found.
:stdMsg
echo:
echo This file is necessary to apply the patch and should present in
echo current directory. Please copy this file from CPU117P2.ZIP archive
echo to current directory and run the batch again.
goto Quit
:noPatch
cls
echo Error: CPU117C.BDF file not found.
goto stdMsg
:Quit
